/*======================================================*/
/*														*/
/*	straightDipFilter.h									*/
/*						(c) HAL 2009-					*/
/*														*/
/*======================================================*/
#include "straightDipFilter.h"

straightDipFilter::straightDipFilter()
{
	this->centerFrequency = 0.0;
	this->bandWidth = 0.0;
	this->rate = 0.0;
}

void straightDipFilter::setFilter( double frequency, double width, double rate )
{
	this->centerFrequency = frequency;
	if( width > 1.0 ){
		this->bandWidth = width;
		this->reverseWidth = 1.0 / width;
		this->logWidth = log( width );
	}else{
		this->bandWidth = 1.0 / width;
		this->reverseWidth = width;
		this->logWidth = log( width );
	}
	this->rate = rate;
}

double straightDipFilter::getFilter( double frequency )
{
	double result = 1.0;
	if( centerFrequency > 0.0 ){
		double temp = frequency / centerFrequency;
		if( 1.0 / bandWidth < temp && temp < bandWidth )
			result = 1.0 + rate * cos( 3.14159216 * log( temp ) / logWidth / 2.0);
	}

	return result;
}
