/*======================================================*/
/*														*/
/*	vConnect.h											*/
/*						(c) HAL 2009-					*/
/*														*/
/*	 vConnect is a sing-synthesis on STRAIGHT.			*/
/*	So all these codes need STRAIGHT Library.			*/
/*														*/
/*======================================================*/
#ifndef __vConnect_h__
#define __vConnect_h__

#include "vConnectObjectBase.h"
#include "vConnectData.h"
#include "straightFileEx.h"
#include "waveFileEx.h"
#include "vConnectConverterBase.h"
#include "vConnectFileManager.h"

static stBool callbackFunc(Straight straight, stCallbackType callbackType,
                           void *callbackData, void *userData);

class vConnect : public vConnectObjectBase {
public:
	vConnect(){ converter = NULL; }

	VCNT_RESULT	initialize( void );
	VCNT_RESULT initialize( vConnectConverterBase* converter ){ this->converter = converter; return initialize(); }
	VCNT_RESULT setConverter( vConnectConverterBase* converter ){ this->converter = converter; return VCNT_TRUE; }
	void		destroy( void );
	VCNT_RESULT	synthesize( string inputFileName, string outputFileName );

protected:
private:
	VCNT_RESULT	initializeFileManager( void );

	vConnectData			data;
	straightFileEx			straightBuffer;
	waveFileEx				waveBuffer;
	vConnectConverterBase*	converter;
	vConnectFileManager		fileManager;
};

#endif
