/*======================================================*/
/*														*/
/*	vConnectData.cpp									*/
/*						(c) HAL 2009-					*/
/*														*/
/*======================================================*/
#include "vConnectData.h"

VCNT_RESULT vConnectData::setFrame( unsigned long frameIndex, vConnectFrame &frame )
{
	VCNT_RESULT result = VCNT_INVALID_CALL;
	if( 0 <= frameIndex && frameIndex < frames.size() ){
		frames[frameIndex].expression.aperiodicityAmplitudeRate = frame.expression.aperiodicityAmplitudeRate;
		frames[frameIndex].expression.spectrumExtentionRate = frame.expression.spectrumExtentionRate;
		frames[frameIndex].expression.volumeAmplitudeRate = frame.expression.volumeAmplitudeRate;
		frames[frameIndex].expression.dipFilters.resize( frame.expression.dipFilters.size() );
		for( unsigned int i = 0; i < frame.expression.dipFilters.size(); i++ )
			memcpy( &(frames[frameIndex].expression.dipFilters[i]), &(frame.expression.dipFilters[i]), sizeof(straightDipFilter) );
		frames[frameIndex].f0 = frame.f0;
		frames[frameIndex].pronounces.resize( frame.pronounces.size() );
		for( unsigned int i = 0; i < frame.pronounces.size(); i++ ){
			frames[frameIndex].pronounces[i].morphRate = frame.pronounces[i].morphRate;
			frames[frameIndex].pronounces[i].absolute = frame.pronounces[i].absolute;
			frames[frameIndex].pronounces[i].relative = frame.pronounces[i].relative;
			frames[frameIndex].pronounces[i].stfFileName = frame.pronounces[i].stfFileName;
			frames[frameIndex].pronounces[i].rightBlank = frame.pronounces[i].rightBlank;
		}
		result = VCNT_TRUE;
	}
	return result;
}

VCNT_RESULT	vConnectData::getFrame( unsigned long frameIndex, vConnectFrame &frame )
{
	VCNT_RESULT result = VCNT_INVALID_CALL;
	if( 0 <= frameIndex && frameIndex < frames.size() ){
		frame.expression.aperiodicityAmplitudeRate = frames[frameIndex].expression.aperiodicityAmplitudeRate;
		frame.expression.spectrumExtentionRate = frames[frameIndex].expression.spectrumExtentionRate;
		frame.expression.volumeAmplitudeRate = frames[frameIndex].expression.volumeAmplitudeRate;
		frame.expression.dipFilters.resize( frames[frameIndex].expression.dipFilters.size() );
		for( unsigned int i = 0; i < frame.expression.dipFilters.size(); i++ )
			memcpy( &(frame.expression.dipFilters[i]), &(frames[frameIndex].expression.dipFilters[i]), sizeof(straightDipFilter) );
		frame.f0 = frames[frameIndex].f0;
		frame.pronounces.resize( frames[frameIndex].pronounces.size() );
		for( unsigned int i = 0; i < frame.pronounces.size(); i++ ){
			frame.pronounces[i].morphRate = frames[frameIndex].pronounces[i].morphRate;
			frame.pronounces[i].absolute = frames[frameIndex].pronounces[i].absolute;
			frame.pronounces[i].relative = frames[frameIndex].pronounces[i].relative;
			frame.pronounces[i].stfFileName = frames[frameIndex].pronounces[i].stfFileName;
			frame.pronounces[i].rightBlank = frames[frameIndex].pronounces[i].rightBlank;
		}
		result = VCNT_TRUE;
	}
	return result;
}