/*======================================================*/
/*														*/
/*	vsqBase.h											*/
/*						(c) HAL 2009-					*/
/*														*/
/*======================================================*/
#ifndef __vsqBase_h__
#define __vsqBase_h__

#include "vConnectObjectBase.h"

#define TICK_PER_BEAT 480
#define CONTROL_CURVE_NUM 7
#define A4_PITCH	440.0
#define A4_NOTE		69

/*  If __UTAU_OFSET__ is defined, preutterance and voiceoverlap */
/* will be treated as offset. So sequence's value will be added */
/* by the value in phoneme DataBase.                            */
//#define __UTAU_OFFSET__

const string controlCurveName[]={
    "[PitchBendBPList]",
    "[PitchBendSensBPList]",
    "[DynamicsBPList]",
    "[EpRResidualBPList]",			/* BRE Curve */
    "[EpRESlopeBPList]",			/* BRI Curve */
    "[EpRESlopeDepthBPList]",		/* CLE Curve */
    "[GenderFactorBPList]"			/* GEN Curve */
};
const int controlCurveDefaultValue[] = {
    0,
    2,
    64,
    0,
    64,
    0,
    64
};
enum{
    PITCH_BEND=0,
    PITCH_BEND_SENS,
    DYNAMICS,
    BRETHINESS,
    BRIGHTNESS,
    CLEARNESS,
    GENDER
};

struct vsqControl{
	int dyn;
	int bre;
	int bri;
	int gen;
	int cle;
	int pit;
	int pbs;
};

class vsqTempo;

class vsqBase : public vConnectObjectBase {
public:
	virtual ~vsqBase(){}
	virtual	void	setParameter( string left, string right ){}
protected:

	static	MAP_TYPE<string,vsqBase*> objectMap;
	static	long	endTick;
	static	long	beginTick;
	static	vsqTempo	tempo;
};

#endif