/*======================================================*/
/*														*/
/*	vsqEventList.h										*/
/*						(c) HAL 2009-					*/
/*														*/
/*======================================================*/
#ifndef __vsqEventList_h__
#define __vsqEventList_h__

#include "vsqBase.h"
#include "vsqEventEx.h"
#include "vsqTempo.h"
#include "vsqPhonemeDB.h"

struct vsqEventProperty {
	vsqEventEx* present;
	vsqEventEx* next;
	unsigned long presentBeginFrame;
	unsigned long presentEndFrame;
	long		  presentActualTick, presentEndTick, presentTick, presentLength;
	char		  presentNote, presentVelocity;
	double		  presentPortamentoLength, presentPortamentoDepth;
	unsigned long nextBeginFrame;
	unsigned long nextEndFrame;
	long		  nextActualTick, nextEndTick;
	char		  nextNote, nextVelocity;
	float		  presentFixedLength, nextFixedLength;
};

class vsqEventList : public vsqBase {
public:
	~vsqEventList();

	void	setParameter( string left, string right );
	long	getBeginTick( void );
	void	getEvents( long tick, vsqEventProperty& notes );
	VCNT_RESULT	initializeAllEvents( vsqTempo& tempo );
	void	applyPreUtterance( void );
	void	setVoiceDataBase( vsqPhonemeDB& voiceDB );

	bool	empty( void ){ return eventList.empty(); }
private:
	vector<vsqEventEx*> eventList;
};

#endif