/*======================================================*/
/*														*/
/*	vsqFileEx.h											*/
/*						(c) HAL 2009-					*/
/*		 vsqFileEx class is the I/O class 				*/
/*						of VOCALOID sequence file.		*/
/*														*/
/*======================================================*/
#ifndef __vsqFileEx_h__
#define __vsqFileEx_h__

#include "vConnectObjectBase.h"
#include "vConnectFrame.h"
#include "vsqMaster.h"
#include "vsqMixer.h"
#include "vsqCommon.h"
#include "vsqEventList.h"
#include "vsqBPList.h"
#include "vsqTempo.h"
#include "vsqPhonemeDB.h"

class vsqFileEx : public vsqBase {
public:
	vsqFileEx();

	VCNT_RESULT	readVsqFile( string fileName );

	long		getBeginTick( void ){ return beginTick; }
	long		getEndTick( void ){ return endTick; }
	void		getControl( long tick, vsqControl& );
	void		getVoicePath( string& dst ){ voiceDataBase.getVoicePath( dst ); }
	void		getEvents( long tick, vsqEventProperty& notes ){ events.getEvents( tick, notes ); }
	long		secondToTick( double second ){ return tempo.secondToTick( second ); }
	double		tickToSecond( long tick ){ return tempo.tickToSecond( tick ); }
protected:
private:
	vector<vsqBPList>	controlCurves;
	vsqEventList		events;
	vsqMaster			master;
	vsqMixer			mixer;
	vsqCommon			common;
	vsqPhonemeDB		voiceDataBase;
};

#endif
